% DeltaZtest.m: Tests the effect of different delta z.
frequency = 100*10^6;
sourceShape = 'gaussian1';
A = 1;
theta0 = 0;
beta = pi/15;


zs = 15;
tx = zs;
rx = zs;
maxHinterestArr = 50;
maxHinterest = maxHinterestArr*zs;
deltaZ1 = 0.5;
deltaZ2 = 1;
deltaZ3 = 1.5;
g = 1.1;
maxX = 3000;
deltaX = 1;
xVect = verticalVector([0:deltaX:maxX]);


% [zVectSSA1,HindexSSA1] =createZvectAbsorptionLayer(maxHinterest,deltaZ1);
% [zVectSSA2,HindexSSA2] =createZvectAbsorptionLayer(maxHinterest,deltaZ2);
% [zVectSSA3,HindexSSA3] =createZvectAbsorptionLayer(maxHinterest,deltaZ3);
%
% initialFieldSSA1 = verticalVector(createInitialField(zs,theta0,beta,zVectSSA1,A, frequency,sourceShape));
% initialFieldSSA2 = verticalVector(createInitialField(zs,theta0,beta,zVectSSA2,A, frequency,sourceShape));
% initialFieldSSA3 = verticalVector(createInitialField(zs,theta0,beta,zVectSSA3,A, frequency,sourceShape));

deltaZarr = [deltaZ1 deltaZ2 deltaZ3];
%initialFieldVect = horzcat(initialFieldSSA1, initialFieldSSA2, initialFieldSSA3);
%HindexVect = [HindexSSA1 HindexSSA2 HindexSSA3];
%zVectArr = horzcat(verticalVector(zVectSSA1), verticalVector(zVectSSA2), ...
%    verticalVector(zVectSSA3));

counter = 0;
doubleCounter = 0;
simulationType_SSA{length(deltaZarr),1} = [];
simulationType_FDM{length(deltaZarr),1} = [];
simulationType_together{2*length(deltaZarr),1} = [];
for n = 1:length(deltaZarr)
    counter = counter +1;
    doubleCounter = doubleCounter +1;
    [zVectSSA1,HindexSSA1] =createZvectAbsorptionLayer(maxHinterest,...
        deltaZarr(n,1));
    initialFieldSSA1 = verticalVector(createInitialField(zs,theta0,beta,...
        zVectSSA1,A, frequency,sourceShape));
    
    %SSA:
    tic
    uValuesSplitStep=splitStepAlgorithmAbsorptionLayer(initialFieldSSA1,...
        zVectSSA1,xVect, HindexSSA1,frequency,g);
    toc
    eField1 = uValuesSplitStep(ceil(HindexVect(n)*(zs/maxHinterest)):...
        ceil(HindexVect(n)*(zs/maxHinterest)),:);
    
    % FDM:
    tic
    [uValuesFDM,maxEigVal] = FDMAbsorptionLayerNumEfficient( ...
        initialFieldSSA1, zVectSSA1,xVect,HindexSSA1,frequency,g);
    toc
    eField1_FDM =uValuesFDM(ceil(HindexSSA1*(zs/maxHinterest)):...
        ceil(HindexVect(n)*(zs/maxHinterest)),:);
    
    if counter == 1
        eFieldTot_SSA = eField1;
        eFieldTot_FDM = eField1_FDM;
        eFieldTot_together = eField1;
         simulationType_together{doubleCounter,1} = ['SSA:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
        doubleCounter = doubleCounter +1;
        eFieldTot_together = vertcat(eFieldTot_together,eField1_FDM); 
         simulationType_together{doubleCounter,1} = ['FDM:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
        
        
    else
        eFieldTot_SSA = vertcat(eFieldTot_SSA,eField1);
        eFieldTot_FDM = vertcat(eFieldTot_FDM,eField1_FDM);
        eFieldTot_together = vertcat(eFieldTot_together,eField1_SSA); 
         simulationType_together{doubleCounter,1} = ['SSA:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    
        doubleCounter = doubleCounter +1;
        eFieldTot_together = vertcat(eFieldTot_together,eField1_FDM); 
        
         simulationType_together{doubleCounter,1} = ['FDM:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    end
    
    % SSA:
    simulationType_SSA{counter,1} = ['SSA:', ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    
    titleVal2 = ['SSA: normal height vector', ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    %contourf(abs(uValuesFiniteDiffMethod).^2,50)
    uValuesSplitStep(abs(uValuesSplitStep)<10^-3) = 10^-3;
    fig = figure('visible','off');
    contourf(xVect,zVectArr(:,n),10.*log10(abs(uValuesSplitStep).^2),20)
    hold on
    contour(xVect,zVectArr(:,n),10.*log10(abs(uValuesSplitStep).^2),20)
    title(titleVal2)
    xlabel('The surface');
    ylabel('Height above surface')
    grid on
    
    titleFig = ['deltaZtest_results/SSA_normal_height_vectors',...
        '_Deltax_',num2str(deltaX),'_max_h_', ...
        num2str(maxHinterestArr), '_Deltaz_',...
        num2str(deltaZarr(n)),'_Ant_h_',num2str(zs),'.png'];
    saveas(fig,titleFig,'png');
    
    % FDM:
    simulationType_FDM{counter,1} = ['FDM:', ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    
    titleVal2 = ['FDM: normal height vector', ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    %contourf(abs(uValuesFiniteDiffMethod).^2,50)
    uValuesFDM(abs(uValuesFDM)<10^-3) = 10^-3;
    fig = figure('visible','off');
    contourf(xVect,zVectArr(:,n),10.*log10(abs(uValuesFDM).^2),20)
    hold on
    contour(xVect,zVectArr(:,n),10.*log10(abs(uValuesFDM).^2),20)
    title(titleVal2)
    xlabel('The surface');
    ylabel('Height above surface')
    grid on
    
    titleFig = ['deltaZtest_results/FDM_normal_height_vectors',...
        '_Deltax_',num2str(deltaX),'_max_h_', ...
        num2str(maxHinterestArr), '_Deltaz_',...
        num2str(deltaZarr(n)),'_Ant_h_',num2str(zs),'.png'];
    saveas(fig,titleFig,'png');
    
end

titleVal3 = ['SSA - normal height vectors',', ', 'Source shape:',' ',...
    sourceShape];
titleFig =['deltaZtest_results/SSA_normal_height_vectors',...
    '_Source_shape_',...
    sourceShape,'Delta_x_',num2str(deltaX),'.png'];
pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot_SSA,zs,...
    beta,frequency,simulationType_SSA, titleVal3,titleFig);

titleVal3 = ['FDM - normal height vectors',', ', 'Source shape:',' ',...
    sourceShape];
titleFig =['deltaZtest_results/FDM_normal_height_vectors',...
    '_Source_shape_',...
    sourceShape,'Delta_x_',num2str(deltaX),'.png'];
pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot_FDM,zs,...
    beta,frequency,simulationType_FDM, titleVal3,titleFig);

titleVal3 =['FDM and SSA - normal height vectors',', ', 'Source shape:',...
    ' ',sourceShape];
titleFig =['deltaZtest_results/FDM_SSA_normal_height_vectors',...
    '_Source_shape_',...
    sourceShape,'Delta_x_',num2str(deltaX),'.png'];
pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot_together,zs,...
    beta,frequency,simulationType_together, titleVal3,titleFig);





% All z-arrays have the same length corresponding to the smallest delta z:

[zVectSSA1,HindexSSA1] =createZvectAbsorptionLayer(maxHinterest,deltaZ1);
%zVectSSA1 = verticalVector([0:deltaZ1:ceil(length(zVectSSA1)/3)]);
%[zVectSSA2,HindexSSA2] =createZvectAbsorptionLayer(maxHinterest,deltaZ2);
%[zVectSSA3,HindexSSA3] =createZvectAbsorptionLayer(maxHinterest,deltaZ3);


% Makes extensions so that the zVect is has the same length as the vector
% for deltaZ1:
zVectSSA2 = verticalVector([0:deltaZ2:(length(zVectSSA1)-1)*deltaZ2]);
L = length(zVectSSA2);
HindexSSA2 = ceil(((L/deltaZ2) +1)*(maxHinterest/L));

zVectSSA3 = verticalVector([0:deltaZ3:(length(zVectSSA1)-1)*deltaZ3]);
L = length(zVectSSA3);
HindexSSA3 = ceil(((L/deltaZ3) +1)*(maxHinterest/L));

initialFieldSSA1 = createInitialField(zs,theta0,beta,zVectSSA1,A, frequency,sourceShape);
initialFieldSSA2 = createInitialField(zs,theta0,beta,zVectSSA2,A, frequency,sourceShape);
initialFieldSSA3 = createInitialField(zs,theta0,beta,zVectSSA3,A, frequency,sourceShape);

deltaZarr = [deltaZ1 deltaZ2 deltaZ3];
initialFieldVect = horzcat(verticalVector(initialFieldSSA1), ...
    verticalVector(initialFieldSSA2), verticalVector(initialFieldSSA3));
HindexVect = [HindexSSA1 HindexSSA2 HindexSSA3];
zVectArr = horzcat(verticalVector(zVectSSA1), verticalVector(zVectSSA2),...
    verticalVector(zVectSSA3));


counter = 0;
doubleCounter = 0;
simulationType_SSA{length(deltaZarr),1} = [];
simulationType_FDM{length(deltaZarr),1} = [];
simulationType_together{2*length(deltaZarr),1} = [];
for n = 1:length(deltaZarr)
    counter = counter +1;
    doubleCounter = doubleCounter +1;
   
    %SSA:
    tic
    uValuesSplitStep = splitStepAlgorithmAbsorptionLayer(...
        initialFieldVect(:,n),zVectArr(:,n),xVect,HindexVect(n),frequency,g);
    toc
    eField1_SSA =uValuesSplitStep(ceil(HindexVect(n)*(zs/maxHinterest)):...
        ceil(HindexVect(n)*(zs/maxHinterest)),:);

    % FDM:
    tic
    [uValuesFDM,maxEigVal] = FDMAbsorptionLayerNumEfficient( ...
        initialFieldVect(:,n),zVectArr(:,n),xVect,HindexVect(n),frequency,g);
    toc
    eField1_FDM =uValuesFDM(ceil(HindexVect(n)*(zs/maxHinterest)):...
        ceil(HindexVect(n)*(zs/maxHinterest)),:);
    
    if counter == 1
        eFieldTot_SSA = eField1;
        eFieldTot_FDM = eField1_FDM;
        eFieldTot_together = eField1;
         simulationType_together{doubleCounter,1} = ['SSA:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
        doubleCounter = doubleCounter +1;
        eFieldTot_together = vertcat(eFieldTot_together,eField1_FDM); 
         simulationType_together{doubleCounter,1} = ['FDM:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
        
        
    else
        eFieldTot_SSA = vertcat(eFieldTot_SSA,eField1);
        eFieldTot_FDM = vertcat(eFieldTot_FDM,eField1_FDM);
        eFieldTot_together = vertcat(eFieldTot_together,eField1_SSA); 
         simulationType_together{doubleCounter,1} = ['SSA:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    
        doubleCounter = doubleCounter +1;
        eFieldTot_together = vertcat(eFieldTot_together,eField1_FDM); 
        
         simulationType_together{doubleCounter,1} = ['FDM:', ' ',...
             '\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    end
    
    % SSA:
    simulationType_SSA{counter,1} = ['SSA:', ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    
    titleVal2 = ['SSA: same length height vector as smallest \Deltaz:',...
        ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    %contourf(abs(uValuesFiniteDiffMethod).^2,50)
    uValuesSplitStep(abs(uValuesSplitStep)<10^-3) = 10^-3;
    fig = figure('visible','off');
    contourf(xVect,zVectArr(:,n),10.*log10(abs(uValuesSplitStep).^2),20)
    hold on
    contour(xVect,zVectArr(:,n),10.*log10(abs(uValuesSplitStep).^2),20)
    title(titleVal2)
    xlabel('The surface');
    ylabel('Height above surface')
    grid on
    
    titleFig = ['deltaZtest_results/SSA_same_length_height_vector_as_',...
        'smallest_Delta_z_Deltax_',num2str(deltaX),'_max_h_', ...
        num2str(maxHinterestArr), '_Deltaz_',...
        num2str(deltaZarr(n)),'_Ant_h_',num2str(zs),'.png'];
    saveas(fig,titleFig,'png');
    
    % FDM:
    simulationType_FDM{counter,1} = ['FDM:', ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    
    titleVal2 = ['FDM: same length height vector as smallest \Deltaz:',...
        ' ','\Deltax =', ' ', ...
        num2str(deltaX),', max h: ', ...
        ' ', num2str(maxHinterestArr), ', ', '\Deltaz =',...
        ' ',num2str(deltaZarr(n)),', ', 'Ant. h: ',num2str(zs)];
    %contourf(abs(uValuesFiniteDiffMethod).^2,50)
    uValuesFDM(abs(uValuesFDM)<10^-3) = 10^-3;
    fig = figure('visible','off');
    contourf(xVect,zVectArr(:,n),10.*log10(abs(uValuesFDM).^2),20)
    hold on
    contour(xVect,zVectArr(:,n),10.*log10(abs(uValuesFDM).^2),20)
    title(titleVal2)
    xlabel('The surface');
    ylabel('Height above surface')
    grid on
    
    titleFig = ['deltaZtest_results/FDM_same_length_height_vector_as_',...
        'smallest_Delta_z_Deltax_',num2str(deltaX),'_max_h_', ...
        num2str(maxHinterestArr), '_Deltaz_',...
        num2str(deltaZarr(n)),'_Ant_h_',num2str(zs),'.png'];
    saveas(fig,titleFig,'png');
    
end

titleVal3 = ['SSA - same length height vector as smallest \Deltaz:',...
    ', ', 'Source shape:',' ', sourceShape];
titleFig =['deltaZtest_results/SSA_same_length_height_vector_as_',...
    'smallest_Delta_z_Source_shape_',...
    sourceShape,'Delta_x_',num2str(deltaX),'.png'];
pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot_SSA,zs,...
    beta,frequency,simulationType_SSA, titleVal3,titleFig);

titleVal3 = ['FDM -  same length height vector as smallest \Deltaz:',...
    ', ', 'Source shape:',' ', sourceShape];
titleFig =['deltaZtest_results/FDM_same_length_height_vector_as_', ...
    'smallest_Delta_z_','_Source_shape_',...
    sourceShape,'Delta_x_',num2str(deltaX),'.png'];
pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot_FDM,zs,...
    beta,frequency,simulationType_FDM, titleVal3,titleFig);

titleVal3=['FDM and SSA - same length height vector as smallest'...
    ' \Deltaz:',', ', 'Source shape:',...
    ' ',sourceShape];
titleFig =['deltaZtest_results/FDM_SSA_same_length_height_vector_as_'...
    'smallest_Delta_z_', '_Source_shape_',...
    sourceShape,'Delta_x_',num2str(deltaX),'.png'];
pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot_together,zs,...
    beta,frequency,simulationType_together, titleVal3,titleFig);



