% IndraWedge.m: Simulations on the wedge given by Indra.

theta0 = 0; %
beta = pi/18; % pi/12; %2*beta = half-power beamwidth
A = 10^(0.9);
frequency = 110*10^6;

% The delta x value:
deltaX = 1; %1.5;
maxX = 1000;
wedgeHeight = 6;

numPtsAbsoptionLayer = 150;

% The delta z value:
deltaZarr =[1];% 1.5]; % 1.5;
antHeight = 3; %[2 3 5 10 15 25];
deltaXvect = [1]; % 1.5];

% The irregular terrain:
Xn = [0 17 20 23 1000];  
Zn = [0 0 6 0 0];  


for a =1:length(antHeight)
    counter = 0;
    doubleCounter = 0;
    
    zs = antHeight(a);
    maxHinterestHeight = 10; % 50; % 25; %[8 14 50];
    numElts = 2;
    simulationType = cell(numElts,1);
    for n = 1:length(deltaXvect)
        
        maxHinterestHeight = 10; % 50; % 25; %[8 14 50];
        
        for heightIndex = 1: length(maxHinterestHeight) %4:5 % 2:3
            
            for  b = 1: length(deltaZarr)
                deltaZ = deltaZarr(b);
                
                counter = counter +1;
                doubleCounter = doubleCounter +1;
                deltaX = deltaXvect(n);
                
                maxHinterest = 350 +zs;
                
                [xVect,zSurfaceVect] = interpolate(Xn,Zn,frequency,...
                    'linear',deltaX);
                
                [zVectFDM,HindexFDM] =createZvectAbsorptionLayer2(...
                    maxHinterest,deltaZ,numPtsAbsoptionLayer);
                initialFieldFDM = createInitialField(zs,theta0,beta,...
                    zVectFDM,A, frequency,'gaussian1');
                numZpoints = length(zVectFDM);
                
                tic
                uValuesSplitStep = SSAirregularTerrainAbsoptionLayer(...
                    initialFieldFDM,zVectFDM,...
                    xVect,zSurfaceVect,HindexFDM,frequency,...
                    numPtsAbsoptionLayer,zs);
                toc
                tic
                uValuesFDM = FDMirregularTerrainAbsorptionLayer ...
                    (initialFieldFDM,zVectFDM,xVect,zSurfaceVect,...
                    HindexFDM,frequency,numPtsAbsoptionLayer);
                toc
                
                eFieldSSA = zeros(1,length(zVectFDM));
                eFieldFDM = zeros(1,length(zVectFDM));
                for i = 1:length(zVectFDM)
                    eFieldSSA(1,i) = uValuesSplitStep(i,...
                       length(xVect));
                    eFieldFDM(1,i) = uValuesFDM(i,...
                         length(xVect));
                end
                
                deltaZstr = num2str(deltaZ);
                yText = strcat('Height above surface [m]');
                
                simulationType{doubleCounter,1} = ['SSA'];
                doubleCounter = doubleCounter +1;
                simulationType{doubleCounter,1} = ['FDM'];
                tx = zs;
                rx = zs;
                
                if counter == 1
                    eFieldTot = eFieldSSA;
                    eFieldTot = vertcat(eFieldTot,eFieldFDM);
                else
                    eFieldTot = vertcat(eFieldTot,eFieldSSA);
                    eFieldTot = vertcat(eFieldTot,eFieldFDM);
                end
                
                fig2 = figure('visible','on');
                
                part1Title = ['Split-Step Algorithm - wedge'];
                part12Titile = [ ' ','\Deltaz = ',' ',deltaZstr,...
                    'm, ','\Deltax = ',' ', ...
                    num2str(deltaX),'m, Source height: ', ...
                    num2str(antHeight(a)),'m, Wedge height: '...
                    num2str(wedgeHeight)];
                part21Title = ['Distance from center point of ',...
                    'source to beginning of absorption layer: ',...
                    num2str(maxHinterest-zs),'m' ];
                part2Title=['Number of points in absorption layer:',...
                    ' ', num2str(numPtsAbsoptionLayer)];
                
                titleVal2 = {part1Title;part12Titile;part21Title;...
                    part2Title};
                
                uValuesAux = uValuesSplitStep;
                uValuesAux(abs(uValuesAux)<10^-4) = 10^-4;
                contourf(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                hold on
                contour(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                %title(titleVal2)
                xlabel('The surface');
                ylabel(yText);
                grid on
                titleFig =['IndraWedge_results/SSA_IndraWedge1.png'];
                saveas(fig2,titleFig,'png');
                %print (fig2, '-dpdf', titleFig);
                
                
                fig = figure('visible','on');
                
                part1Title = ['Finite-Difference Method - wedge'];
                part12Titile = [ ' ','\Deltaz = ',' ',deltaZstr,...
                    'm, ','\Deltax = ',' ', ...
                    num2str(deltaX),'m, Source height: ', ...
                    num2str(antHeight(a)),'m, Wedge height: '...
                    num2str(wedgeHeight)];
                part21Title = ['Distance from center point of ',...
                    'source to beginning of absorption layer: ',...
                    num2str(maxHinterest-zs),'m' ];
                part2Title=['Number of points in absorption layer:',...
                    ' ', num2str(numPtsAbsoptionLayer)];
                
                titleVal2 = {part1Title;part12Titile;part21Title;...
                    part2Title};
                
                uValuesAux = uValuesFDM;
                uValuesAux(abs(uValuesAux)<10^-4) = 10^-4;
                contourf(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                hold on
                contour(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                %title(titleVal2)
                xlabel('The surface');
                ylabel(yText);
                grid on
                titleFig =['IndraWedge_results/FDM_IndraWdge1.png'];
                
                saveas(fig,titleFig,'png');
                %titleFig2=['IndraWedge_results/FDM_IndraWdge1.pdf'];
                %print (fig, '-dpdf', titleFig2);
                
            end
            
            tx =zs;
            rx = zs;
            part1Title = ['SSA and FDM - wedge '];
            part12Titile = [ ' ','\Deltaz = ',' ',deltaZstr,...
                'm, ','\Deltax = ',' ', ...
                num2str(deltaX),'m, Source height: ', ...
                num2str(antHeight(a)),'m, Wedge height: '...
                num2str(wedgeHeight)];
            part21Title = ['Distance from center point of ',...
                'source to beginning of absorption layer: ',...
                num2str(maxHinterest-zs),'m' ];
            part2Title=['Number of points in absorption layer:',...
                ' ', num2str(numPtsAbsoptionLayer)];
            
            plotTitle = {part1Title;part12Titile;part21Title;...
                part2Title};
            
            titleFig =['IndraWedge_results/SSA_FDM_IndraWedge1_wedge.png'];
           
            filename = 'IndraWedge_results/LPDA-kile_E.xls';
            rx_xArr = ones(length(zVectFDM),1).*length(xVect);
            rx_zArr = zVectFDM;
            
            
            pathLossWedge_Indra(Xn,Zn,deltaX,A,tx,rx_xArr,rx_zArr,...
                eFieldTot,zs,...
                beta,frequency,simulationType,' ',titleFig,filename);
           
        end
        
    end
end





