% parabolicEquationBC.m

% Testing for boundary conditions added:

% testSquareMatrix.m: Tests the hypothesis regarding square matrices easier
%                     give stability, for a maximum delta x. The range
%                     being calculated depends on delta z. This is for the
%                     finite-difference method.

testResults = 'FDM_resultsFolder/test1.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Testing stability for square matrices where delta x = 1.5m');
fprintf(fileID, '%s\r\n', ' ');



theta0 =0;% pi/4;% 0;
beta = pi/15; % 0.5;
A = 2;
frequency = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);

g = 1.3;
fprintf(fileID, '%s', 'g value: ');
fprintf(fileID, '%4.3f\r\r\n', g);

% The delta x value:
deltaX =1; % 1.5;
fprintf(fileID, '%s', 'Delta x: ');
fprintf(fileID, '%4.3f\r\r\n', deltaX);
maxX = 1000;
fprintf(fileID, '%s', 'Max x: ');
fprintf(fileID, '%4.3f\r\r\n', maxX);
fprintf(fileID, '%s\r\n', ' ');
fprintf(fileID, '%s\r\n', ' ');

maxHinterestHeight =10; %[5 10 20]; %15; %[5 10]; % 50]; %50; % 25;%; %[8 14 50];
numLayersArray  =10; %5; %10; %[3 10 15];
numPointsPerLayerArray =20; %15; %10;% [10 20 30];
numElts = length(numPointsPerLayerArray);
numPointsInLayer =100;
% The delta z value:
deltaZarr = 1.0; %0.09; %[0.5 0.3]; % [0.6 0.55 0.525 0.5 0.475 0.45 0.4 0.35 0.3]; %[0.3 0.2 0.1 0.09];
parfor b = 1: length(deltaZarr)
    deltaZ = deltaZarr(b);
    fprintf(fileID, '%s', 'Delta z: ');
    fprintf(fileID, '%4.3f\r\n', deltaZ);
    
    
    antHeight =10; % 25; %[7.5]; %[7.5]; % 10];
    for a =1:length(antHeight)
        counter = 0;
        simulationType = cell(numElts,1);
        for heightIndex = 1: length(maxHinterestHeight) %4:5 % 2:3
            for n = 1: length(numLayersArray)
                
                for m = 1: length(numPointsPerLayerArray)
                    counter = counter +1;
                    numLayers = numLayersArray(n);
                    numPointsPerLayer = numPointsPerLayerArray(m);
                    
                    zs = antHeight(a);
                    fprintf(fileID, '%s\r\n', ' ');
                    fprintf(fileID, '%s', '    Antenna height: ');
                    fprintf(fileID, '%4.2f m\r\n', zs);
                    
                    
                    maxHinterest = 250+zs; %maxHinterestHeight(heightIndex)*zs; % heightIndex*zs;
                    fprintf(fileID, '%s', '        Maximum height of interest (in terms of multiple of antenna height): ');
                    fprintf(fileID, '%4.2f m\r\n', maxHinterestHeight(heightIndex));
                    
                    
                    [zVectFDM,HindexFDM] =createZvectAbsorptionLayer2( ...
                        maxHinterest, deltaZ,numPointsInLayer)
                    initialFieldFDM =createInitialField(zs,theta0,beta,zVectFDM,...
                        A, frequency,'gaussian1');
                    numZpoints = length(zVectFDM);
                    %figure()
                    %plot(abs(initialFieldFDM))
                    
                    % Creating the x vector:
                    xVect = verticalVector([0:deltaX:maxX]);
                    
                    fprintf(fileID, '%s', '        Distance: ');
                    fprintf(fileID, '%5.1f\r\n', xVect(numZpoints));
                    
                    
                    numIterations = ceil(maxX/xVect(numZpoints));
                    xVectTot = xVect;
                    tic
                    [uValuesFDMalne,maxEigVal] = FDMAbsorptionLayerNumEfficient2(initialFieldFDM, ...
                        zVectFDM,xVect,HindexFDM,frequency,numPointsInLayer);
                    uValuesTot = uValuesFDMalne;
                    toc
                    %             for it = 1: numIterations
                    %                 initField = uValuesFDMalne(:,numZpoints);
                    %                 tic
                    %             [uValuesFDMalne,maxEigVal] = FDMAbsorptionLayerNumEfficient(initField, ...
                    %                 zVectFDM,xVect,HindexFDM,frequency,g);
                    %             toc
                    %             uValuesTot = horzcat(uValuesTot,uValuesFDMalne);
                    %             xVectTot = vertcat(xVectTot, (xVect + xVectTot(length(xVectTot))));
                    %             end
                    
                    
                    
                    fprintf(fileID, '%s', '        Maximum eigenvalue:');
                    fprintf(fileID, '%4.6f\r\n', maxEigVal);
                    fprintf(fileID, '%s\r\n', ' ');
                    
                    deltaZstr = num2str(deltaZ);
                    yText = 'Height above surface [m]';
                    %
                    
                    eField = uValuesTot(ceil(HindexFDM*(zs/maxHinterest)):ceil(HindexFDM*(zs/maxHinterest)),:);
                    simulationType{counter,1} = ['FDM - Calculation domain height: ',...
                        num2str(maxHinterest),'*',' antenna height [m]'];
                    
                    %                     simulationType{counter,1} = ['FDM - \Deltaz = ',' ',deltaZstr,', ','\Deltax = ',' ', ...
                    %                         num2str(deltaX), 'Num pts absorption layer: ',...
                    %                         num2str(numLayers*numPointsPerLayer)];
                    %                         ', ','N layers: ',...
                    %                         num2str(numLayers),', N pts/layer: ',...
                    %                         num2str(numPointsPerLayer)];
                    
                    if counter == 1
                        eFieldTot = eField;
                    else
                        
                        eFieldTot = vertcat(eFieldTot,eField);
                    end
                    
                    tx = zs;
                    rx = zs;
                    
                    fig = figure('visible','off');
                    uValuesAux = uValuesTot;
                    uValuesAux(abs(uValuesAux)<10^-4) = 10^-4;
                    contourf(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                    hold on
                    contour(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)

                    part1Title = ['FDM - absorption layer test , ant h.:',...
                        ' ',num2str(antHeight(a)), ...
                        ' ','\Deltaz = ',' ',deltaZstr,', ','\Deltax = ',' ', ...
                        num2str(deltaX),', ','Max h: ',...
                        num2str(maxHinterestHeight(heightIndex))];
                    part2Title = ['Num pts absorption layer: ',...
                        num2str(numPointsInLayer)];
                    %                         'Number ',...
                    %                     'of layers:'...
                    %                     ,' ', num2str(numLayers),', Number of points per'...
                    %                     ,' layer: ',num2str(numPointsPerLayer)]
                    titleVal2 = {part1Title;part2Title};
                    title(titleVal2)
                    xlabel('The surface [m]');
                    ylabel(yText); %'Height above surface, \Delta z = %2.1f', deltaZ)
                    grid on
                    titleFig = ['FDM_resultsFolder/FDM_AbsorptioLayerTest_ant_h_','_',num2str(antHeight(a)), ...
                        '_','Deltaz','_',deltaZstr,'_','Deltax_','_', ...
                        num2str(deltaX),'_max_h_',...
                        num2str(maxHinterestHeight(heightIndex)), ...
                        'num_points_layer', num2str(numPointsInLayer),...
                        '.png'];
                    saveas(fig,titleFig,'png');
                end
            end
        end
        plotTitle = {['FDM - absorption layer test , ant h.:',...
            ' ',num2str(antHeight(a)), ...
            ' ','\Deltaz = ',' ',deltaZstr,', ','\Deltax = ',' ', ...
            num2str(deltaX),', ','Max h: ',...
            num2str(maxHinterestHeight(heightIndex))];['Number ',...
            'of points in absorption layer:'...
            ,' ', num2str(numPointsInLayer)]};
        titleFig = ['FDM_resultsFolder/FDM_AbsorptioLayerTest_ant_h_','_',num2str(antHeight(a)), ...
            '_','Deltaz','_',deltaZstr,'_','Deltax_','_', ...
            num2str(deltaX),'_max_h_',...
            num2str(maxHinterestHeight(heightIndex)), ...
            'num_points_layer', num2str(numPointsInLayer),...
            'newAbsLAyer4','.png'];
       
        pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
            beta,frequency,simulationType, plotTitle,titleFig)
        
    end
end


fclose(fileID);


%%

