% parabolicEquationBC_FDM.m

% Testing for boundary conditions added:

% testSquareMatrix.m: Tests the hypothesis regarding square matrices easier
%                     give stability, for a maximum delta x. The range
%                     being calculated depends on delta z. This is for the
%                     finite-difference method.

testResults = 'BoundaryConditionResults/FDM_testresults_parabolicEquationBC.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Testing stability for square matrices where delta x = 1.5m');
fprintf(fileID, '%s\r\n', ' ');
fprintf(fileID, '%s\r\n', 'Boundary Condtions implemented.');
fprintf(fileID, '%s\r\n', ' ');


theta0 = 0; % pi/4;% 0;
beta = pi/18; % pi/30; % 0.5;
A = 1;
frequency = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);

g = 0.05; % 1.3;
fprintf(fileID, '%s', 'g value: ');
fprintf(fileID, '%4.3f\r\r\n', g);

% The delta x value:
deltaX = 1; %1.5;
fprintf(fileID, '%s', 'Delta x: ');
fprintf(fileID, '%4.3f\r\r\n', deltaX);
maxX = 5000;
fprintf(fileID, '%s', 'Max x: ');
fprintf(fileID, '%4.3f\r\r\n', maxX);
fprintf(fileID, '%s\r\n', ' ');
fprintf(fileID, '%s\r\n', ' ');

% The delta z value:
deltaZarr =[1];% 1.5]; % 1.5; %0.09; %[0.5 0.3]; % [0.6 0.55 0.525 0.5 0.475 0.45 0.4 0.35 0.3]; %[0.3 0.2 0.1 0.09];
antHeight = [2 3 5 10 15 25]; %15; %7.5; %[2 7.5 15 25]; %[7.5]; % 10];
deltaXvect = [1]; % 1.5];

for a =1:length(antHeight)
    %simulationType{numElts,1} = []; % {length(maxHinterestHeight),1} = [];
    zs = antHeight(a);
    for n = 1:length(deltaXvect)
        
        maxHinterestHeight = 10; % 50; % 25; %[8 14 50];
        numElts = length(maxHinterestHeight)*length(deltaXvect);
        simulationType = cell(numElts,1);
        %simulationType{numElts,1} = [];
        counter = 0;
        
        
        
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', '    Antenna height: ');
        fprintf(fileID, '%4.2f m\r\n', zs);
        
        
        for heightIndex = 1: length(maxHinterestHeight) %4:5 % 2:3
            
            
            %plot(abs(initialFieldFDM))
            
            % Creating the x vector:
            for  b = 1: length(deltaZarr)
                deltaZ = deltaZarr(b);
                fprintf(fileID, '%s', 'Delta z: ');
                fprintf(fileID, '%4.3f\r\n', deltaZ);
                counter = counter +1;
                deltaX = deltaXvect(n);
                xVect = verticalVector([0:deltaX:maxX]);
                maxHinterest = 250 +zs; % maxHinterestHeight(heightIndex)*zs; % heightIndex*zs;
                fprintf(fileID, '%s', '        Maximum height of interest (in terms of multiple of antenna height): ');
                fprintf(fileID, '%4.2f m\r\n', maxHinterestHeight(heightIndex));
                
                
                [zVectFDM,HindexFDM] =createZvectAbsorptionLayer2(maxHinterest,deltaZ);
                initialFieldFDM = createInitialField(zs,theta0,beta,zVectFDM,A, frequency,'circular');
                numZpoints = length(zVectFDM);
                
                fprintf(fileID, '%s', '        Distance: ');
                fprintf(fileID, '%5.1f\r\n', xVect(numZpoints));
                
                
                numIterations = ceil(maxX/xVect(numZpoints));
                tic
                [uValuesFDMalne,maxEigVal] = FDMAbsorptionLayerNumEfficient(initialFieldFDM, ...
                    zVectFDM,xVect,HindexFDM,frequency,g);
                
                toc
                
                fprintf(fileID, '%s', '        Maximum eigenvalue:');
                fprintf(fileID, '%4.6f\r\n', maxEigVal);
                fprintf(fileID, '%s\r\n', ' ');
                
                deltaZstr = num2str(deltaZ);
                yText = strcat('Height above surface, \Delta z ',deltaZstr);
                %
                
                eField = uValuesFDMalne(ceil(HindexFDM*(zs/maxHinterest)):ceil(HindexFDM*(zs/maxHinterest)),:);
                %             simulationType2 = cell(1);
                %             simulationType2{1} = 'FDM-bc';
                simulationType{counter,1} = ['FDM-bc:', ' ','\Deltax =', ' ', ...
                    num2str(deltaX),', max h: ', ...
                    ' ', num2str(maxHinterestHeight(heightIndex)),', ','\Deltaz= ',num2str(deltaZ)];
                tx = zs;
                rx = zs;
                
                if counter == 1
                    eFieldTot = eField;
                else
                    
                    eFieldTot = vertcat(eFieldTot,eField);
                end
                
                
                fig = figure('visible','off');
                titleVal2 = ['FDM, square matrix, ant h.:',' ',num2str(antHeight(a)), ...
                    ' ','\Deltaz = ',' ',deltaZstr,', ','\Deltax = ',' ', ...
                    num2str(deltaX),', ','Max h: ',];
                              
                uValuesAux = uValuesFDMalne;
                uValuesAux(abs(uValuesAux)<10^-3) = 10^-3;
                contourf(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),20)
                hold on
                contour(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),20)
                title(titleVal2)
                xlabel('The surface');
                ylabel(yText); %'Height above surface, \Delta z = %2.1f', deltaZ)
                grid on
                titleFig = ['FDM_resultsFolder/FDM_ant_h_','_',num2str(antHeight(a)), ...
                    '_','Deltaz','_',deltaZstr,'_','Deltax_','_', ...
                    num2str(deltaX),'_max_h_',num2str(maxHinterestHeight(heightIndex)),'.png'];
                saveas(fig,titleFig,'png');
                
            end
            % titleVal = ['FDM-bc, square matrix, ant h:',' ',num2str(antHeight(a)), ...
            %     ' ',deltaZstr,', ','\Deltax = ',' ', ...
            %     num2str(deltaX)];
            % pathLossFlat(tx,rx,xVect,eFieldTot,zs, frequency, simulationType,titleVal);
            tx =zs;
            rx = zs;
            titleVal3 = ['FDM-bc beam param, square matrix, ant h:',' ',num2str(antHeight(a)), ...
                ' \Deltaz = ',deltaZstr,', ','\Deltax = ',' ', ...
                num2str(deltaX)];
            titleFig =['FDM_resultsFolder/FDM_bc_beam_param_ant_h_',num2str(antHeight(a)), ...
                '_DeltaZ_',deltaZstr,'_deltaX_',num2str(deltaX),'.png'];
            pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
                beta,frequency,simulationType, titleVal3,titleFig);
            
            
        end
        
    end
    
    
end

fclose(fileID);




