% ParabolicEquationBC_FDM_irregularTerrain.m: Script that calculates the
% e-field behind a wedge.

% create file:
testResults = 'testResults_FDM_irregularTerrain.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Comparing with ITU model for wedge diffraction');
fprintf(fileID, '%s\r\n', ' ');
eField = 0;
distance = 1000;
frequency  = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);
fprintf(fileID, '%s\r\n', 'Distance: ');
maxX = 3000;
fprintf(fileID, '%5.1f\r\n', maxX);

theta0 = 0;
beta = pi/15; % 0.5;
A = 2;


fprintf(fileID, '%s\r\n', ' ');

% Setting deltaZ:
deltaZarr =1; %1.5; %[0.5 1 1.5]; %1.5;%1.5; %0.5; %1.5; % [0.3 0.7 1.5]; % [0.3 0.2 0.1 0.09]; %[1.5 1 0.9 0.6 0.3 0.06];% [0.01 0.05 0.09 0.9];% [0.006 0.009 0.01 0.05 0.09 0.9];
antHeight =10; % 25; % 7.5; %[2.5 3 7.5 10]; % 25];
maxHinterestArr =100; % 200; %100; %50; %50; % 200; % [8 10 14 25 50 200]; % [2 3 4 5 6 7 8];
gVect = 1.1; %1.3; %[1.1 1.3 1.5 1.9]; %[0.001 0.01 0.1 1.1];
deltaXvect =1; % [1 1.5]; %[0.7 1 1.2 1.5];
numElts = length(deltaZarr)*length(antHeight)*length(maxHinterestArr)...
    *length(gVect)*length(deltaXvect);
counter = 0;
simulationType {length(numElts),1} = [];
numPtsInLayer = 150;
for b = 1: length(deltaZarr)
    b
    deltaZ = deltaZarr(b);
    
    fprintf(fileID, '%s\r\n', ' ');
    fprintf(fileID, '%s\r\n', ' ');
    fprintf(fileID, '%s', 'Delta z: ');
    fprintf(fileID, '%4.3f\r\n', deltaZ );
    fprintf(fileID, '%s\r\n', ' ');
    
    
    for a = 1:length(antHeight)
        a
        zs = antHeight(a); % 7.5;
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', '    Antenna height: ');
        fprintf(fileID, '%4.2f m\r\n', zs);
        tx = zs;
        rx = zs;
        
        
        for h = 1: length(maxHinterestArr)
            
            maxHinterest = maxHinterestArr(h)*zs;
            fprintf(fileID, '%s\r\n', ' ');
            fprintf(fileID, '%s', '        Max height of interest:');
            fprintf(fileID, '%4.3f\r\r\n', maxHinterest);
            fprintf(fileID, '%s\r\n', ' ');
            
            fprintf(fileID, '%s\r\n', ' ');
            
            
            
            
            
            for m =1:length(gVect)
                %deltaZfdm = 0.009- m*0.003; %0.009:-0.002:0.001
                %m
                g = gVect(m);
                %g
                fprintf(fileID, '%s\r\n', ' ');
                fprintf(fileID, '%s', '        New g value:');
                fprintf(fileID, '%4.3f\r\r\n', g);
                fprintf(fileID, '%s\r\n', ' ');
                
                deltaXvect = [1.5]; % [0.5 0.7 1 1.2 1.5];
                
                for n = 1:length(deltaXvect)
                    counter = counter +1;
                    sourceShape = 'gaussian1';
                    
                    % Creating zVect and initial field:
                    [zVectFDM,HindexFDM] =createZvectAbsorptionLayer2(maxHinterest,deltaZ,numPtsInLayer);
                    
                    % The irregular terrain:
                    Xn =[0 2500 5000]; % [0, 1500, 3000];
                    Zn = [0 50 0]; %[0, 10, 0];
                    deltaX = deltaXvect(n); %
                    [xVect,zSurfaceVect] = interpolate(Xn,Zn,frequency,'linear',deltaX);
                    xVect = verticalVector(xVect); %[0:deltaX:maxX]);
                    
                    %initialFieldSSA = createInitialField(zs,theta0,beta,zVectSSA,A, frequency,sourceShape);
                    initialFieldFDM = createInitialField(zs,theta0,beta,zVectFDM,A, frequency,sourceShape);
                    fprintf(fileID, '%s', '            New delta x value: ');
                    fprintf(fileID, '%4.3f\r\n', deltaX);
                    
                    %xVect = verticalVector([0:deltaX:maxX]);
                    alpha = -0.1;
                    % Calculating the field:%                     uValuesSplitStep = SSA_AbsorptionLayer_BC(initialFieldSSA,zVectSSA,xVect, ...
                    %                         HindexSSA,frequency,g,alpha);
                    disp('begynner utregning');
                    tic
                    uValuesFDM = FDMirregularTerrainAbsorptionLayer ...
                        (initialFieldFDM,zVectFDM,xVect,zSurfaceVect,HindexFDM,frequency,numPtsInLayer);
                    toc
                                     
                    rx_zArr = zVectFDM;
                    
                    rx_xArr = ones(length(zVectFDM),1).*length(xVect);
                    %eField1 = uValuesSplitStep(ceil(HindexSSA*(zs/maxHinterest)):ceil(HindexSSA*(zs/maxHinterest)),:);
                    simulationType{counter,1} = ['FDM:', ' ','\Deltax =', ' ', ...
                        num2str(deltaXvect(n)),', max h: ', ...
                        ' ', num2str(maxHinterestArr(h)), ', ', '\Deltaz =',...
                        ' ',num2str(deltaZ),', ', 'Ant. h: ',num2str(antHeight(a))];
                    eField1 = zeros(length(zVectFDM),1);
                    for i = 1:length(zVectFDM)
                        %disp('henter verdier')
                        %i
                        eField1(i,1) = uValuesFDM(i,rx_xArr(i));
                        %disp('har fatt verdien')
                    end
                    
                    % Plotting both eFields in the same plot
                    if counter == 1
                        disp('gaar dette bra?');
                        eFieldTot = eField1;
                        disp('Ja!');
                        %uValuesTot = uValuesSplitStep;
                    else
                        eFieldTot = vertcat(eFieldTot,eField1); %,eField2);
                        %uValuesTot = horzcat(uValuesTot,uValuesSplitStep);
                    end
                end
            end
            disp('Skal plotte feltet');
            figure()
            titleVal2 = ['FDM - u-values', ' ', num2str(antHeight(a)), 'm', ...
                ' ', '\Deltaz =', ' ',num2str(deltaZarr(b))];
            %contourf(abs(uValuesFiniteDiffMethod).^2,50)
            auxUvalues = uValuesFDM;
            auxUvalues(abs(auxUvalues)<10^-4) = 10^-4;
            contourf(10.*log10(abs(auxUvalues).^2),20)
            hold on
            contour(10.*log10(abs(auxUvalues).^2),20)
            title(titleVal2)
            xlabel('The surface');
            ylabel('Height above surface')
            grid on
        end
        %          titleVal = ['SSA - Pahtloss for antenna height:', ' ', num2str(antHeight(a)), 'm', ...
        %         ' ', '\Deltaz =', ' ',num2str(deltaZarr(b))];
        %     pathLossFlat(tx,rx,xVect,eFieldTot,zs, frequency, simulationType,titleVal)
        
        %      titleVal3 = ['SSA - analytical beam param, square matrix, antenna height:','m,',' ',num2str(antHeight(a)), ...
        %             ' ','\Deltaz = ',' ',num2str(deltaZ),', ','\Deltax = ',' ', ...
        %             num2str(deltaX), 'Source shape:',' ',sourceShape];
        %         pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
        %     beta,frequency,simulationType, titleVal3);
        
    end
end
titleVal3 = ['FDM - analytical beam param irregular terrain',', ', 'Source shape:',' ', ...
    sourceShape];
% pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
%     beta,frequency,simulationType, titleVal3);

rx_xArr = ones(length(rx_xArr),1)*xVect(length(xVect));
pathLossWedge_beamParam(Xn,Zn,deltaX,A,tx,rx_xArr,rx_zArr,eFieldTot,zs,...
    beta,frequency,simulationType, titleVal3)

fclose(fileID);








