% parabolicEquation_SSA_FDM_deltaValueTes.m: Script simulating the ''slow''
%                                            propagation, the value of
%                                            delta x and delta z is small


% Setting the parameters:
theta0 = 0; 
beta = pi/18;
A = 1;
frequency = 110*10^6;
deltaX = 1;
maxX = 3000;
numPtsAbsoptionLayer = 150;
deltaZarr =[0.3];
antHeight = [15];
deltaXvect = [0.3];

for a =1:length(antHeight)
    counter = 0;
    doubleCounter = 0;
    
    zs = antHeight(a);
    maxHinterestHeight = 10;
    numElts = 2;
    simulationType = cell(numElts,1);
    
    % Looping over the delta x values:
    for n = 1:length(deltaXvect)
        
        maxHinterestHeight = 10;
        
        for heightIndex = 1: length(maxHinterestHeight)
            
           % Looping over the delta z values:
            for  b = 1: length(deltaZarr)
                deltaZ = deltaZarr(b);
                
                counter = counter +1;
                doubleCounter = doubleCounter +1;
                deltaX = deltaXvect(n);
                xVect = verticalVector([0:deltaX:maxX]);
                maxHinterest = 350 +zs;
                
                % Creating initial field:
                [zVectFDM,HindexFDM] =createZvectAbsorptionLayer2(...
                    maxHinterest,deltaZ,numPtsAbsoptionLayer);
                initialFieldFDM = createInitialField(zs,theta0,beta,...
                    zVectFDM,A, frequency,'gaussian1');
                numZpoints = length(zVectFDM);
                
                % Calculating field:
                tic
                uValuesSplitStep =splitStepAlgorithmAbsorptionLayer(...
                    initialFieldFDM,zVectFDM,xVect, ...
                    HindexFDM,frequency,numPtsAbsoptionLayer);
                toc
                tic
                [uValuesFDMalne,maxEigVal]=...
                    FDMAbsorptionLayerNumEfficient2(initialFieldFDM, ...
                    zVectFDM,xVect,HindexFDM,frequency,...
                    numPtsAbsoptionLayer);
                toc
                
                deltaZstr = num2str(deltaZ);
                yText = strcat('Height above surface [m]');
                
                % Extracting field at the height of interest, the antenna
                % height:
                eFieldSSA=uValuesSplitStep(...
                    ceil(HindexFDM*(zs/maxHinterest)),:);
                eFieldFDM=uValuesFDMalne(...
                    ceil(HindexFDM*(zs/maxHinterest)),:);
               
                simulationType{doubleCounter,1} = ['SSA:'];
                doubleCounter = doubleCounter +1;
                simulationType{doubleCounter,1} = ['FDM:'];
                tx = zs;
                rx = zs;
                
                if counter == 1
                    eFieldTot = eFieldSSA;
                    eFieldTot = vertcat(eFieldTot,eFieldFDM);
                else
                    eFieldTot = vertcat(eFieldTot,eFieldSSA);
                    eFieldTot = vertcat(eFieldTot,eFieldFDM);
                end
                
                % Plotting the fields:
                fig2 = figure('visible','off');
                uValuesAux = uValuesSplitStep;
                uValuesAux(abs(uValuesAux)<10^-4) = 10^-4;
                contourf(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                hold on
                contour(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                xlabel('The surface');
                ylabel(yText);
                grid on
                titleFig = ['DeltaValueTest_results/SSA', ...
                    '_','Deltaz','_',deltaZstr,'_','Deltax_','_', ...
                    num2str(deltaX),'freq_',...
                    num2str(frequency/(10^6)),'_deltaTest.png'];
                saveas(fig2,titleFig,'png');
                
                
                fig = figure('visible','off');
               
                uValuesAux = uValuesFDMalne;
                uValuesAux(abs(uValuesAux)<10^-4) = 10^-4;
                contourf(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                hold on
                contour(xVect,zVectFDM,10.*log10(abs(uValuesAux.^2)),50)
                xlabel('The surface');
                ylabel(yText);
                grid on
                titleFig = ['DeltaValueTest_results/FDM', ...
                    '_','Deltaz','_',deltaZstr,'_','Deltax_','_', ...
                    num2str(deltaX),'freq_',...
                    num2str(frequency/(10^6)),'_deltaTest_deltaTest.png'];
                saveas(fig,titleFig,'png');
                
            end
            
            tx =zs;
            rx = zs;
            
            plotTitle =' ';
            titleFig = ['DeltaValueTest_results/SSA_FDM', ...
                '_','Deltaz','_',deltaZstr,'_','Deltax_','_', ...
                num2str(deltaX),'freq_',...
                    num2str(frequency/(10^6)),'_deltaTest.png'];
                
            % Comparing path loss of simulated field with the analytical 
            % path loss    
            pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
                beta,frequency,simulationType, plotTitle,titleFig);
            
        end
    end
end





