% beamShapePlotPolar.m: Plots the beam shape for a gaussian beam, both
%                       cartesian plot and polar plot, the last one in dB.

% Assuming the the antenna to be placed on a virtual zero (like zero
% height):

A = 1; % Amplitude
beta_deg = 70; %45; % 20; % grader
beta_rad = (beta_deg/360)*2*pi;

thetaMin = -pi;
thetaMax = pi;
numPoints = 100;

thetaArr = linspace(thetaMin,thetaMax,numPoints);
beamShape = A.*exp(-2.*log10(2).*(thetaArr.^2)./(beta_rad.^2));

figure();
plot(thetaArr,beamShape);

figure();
polar(thetaArr,20.*log10(beamShape));
figure();
polar(thetaArr,beamShape);