% discreteSineTrans.m: Performs a discrete sine transform of given set of 
%                      values, xIn
% xIn: Vector containing the input values

% return: dst: Vector containing the calculated values.

function dst = discreteSineTrans(xIn)
numPoints = length(xIn);
dst = zeros(numPoints,1);
indices = verticalVector(linspace(1,numPoints,numPoints));

for k = 1:numPoints
    dst(k) = sum(xIn.*sin(pi.*k.*indices./(numPoints+1)));
end
end

