% importParametersFromFile.m: Imports the surface profile
%                             coordinates from file.

% fileName: String containing the file name
% xColumnNb: The column number containing the x-coordinates.
% zColumnNB: The column number containing the z-coordinates.

% return: Xn: Vector containing the x-coordinates of the surface
%         Zn: Vector containing the z-coordinates of the surface


function [Xn,Zn]=importParametersFromFile(fileName,xColumnNb,zColumnNB) 
fileValues = xlsread(fileName);
Xn = fileValues(:,xColumnNb);
Zn = fileValues(:,zColumnNB);
end
