% inverseDiscreteSineTrans.m: Performs the inverse sine transformation on a
%                             given set of values, yIn
% yIn: Vector containing the input values

% return: idst: Vector containg the calculated values

function idst = inverseDiscreteSineTrans(yIn)
numPoints = length(yIn);
idst = zeros(numPoints,1);
indices = verticalVector(linspace(1,numPoints,numPoints));

for k = 1:numPoints
    idst(k) =(2./(numPoints+1)).*sum(yIn.*sin(pi.*k.*indices./(numPoints+1)));
end
end

