% ParabolicEquationBC_SSA.m:
% Script testing path loss

% create file:
testResults = 'testResults_splitStep4_newField_maxHeightInterestVarying.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Testing for stability, varying delta z, antenna height, the g-value (refractive index) and delta x:');
fprintf(fileID, '%s\r\n', ' ');
eField = 0;
distance = 3000;
frequency  = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);
fprintf(fileID, '%s\r\n', 'Distance: ');
maxX = 3000;
fprintf(fileID, '%5.1f\r\n', maxX);

theta0 = 0;
beta = pi/15; % 0.5;
A = 2;


fprintf(fileID, '%s\r\n', ' ');

% Setting deltaZ:
deltaZarr =1; %[0.5 1 1.5]; %1.5;%1.5; %0.5; %1.5; % [0.3 0.7 1.5]; % [0.3 0.2 0.1 0.09]; %[1.5 1 0.9 0.6 0.3 0.06];% [0.01 0.05 0.09 0.9];% [0.006 0.009 0.01 0.05 0.09 0.9];
antHeight = 3; %[2 7.5 15 25]; % 7.5; %[2.5 3 7.5 10]; % 25];
maxHinterestArr = 50; % 200; % [8 10 14 25 50 200]; % [2 3 4 5 6 7 8];
gVect = 1.1; %1.3; %[1.1 1.3 1.5 1.9]; %[0.001 0.01 0.1 1.1];
deltaXvect =1;% [0.5 1 1.5]; %[0.7 1 1.2 1.5];
numElts = length(maxHinterestArr)...
    *length(gVect); % *length(deltaXvect);
%counter = 0;
numPtsAbsoptionLayer = 100; 
for a = 1:length(antHeight)
    
    for b = 1: length(deltaZarr)
        simulationType = cell(numElts,1);
        counter = 0;
        b
        deltaZ = deltaZarr(b);
        
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', 'Delta z: ');
        fprintf(fileID, '%4.3f\r\n', deltaZ );
        fprintf(fileID, '%s\r\n', ' ');

        a
        zs = antHeight(a); % 7.5;
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', '    Antenna height: ');
        fprintf(fileID, '%4.2f m\r\n', zs);
        tx = zs;
        rx = zs;
        
        for h = 1: length(maxHinterestArr)
            
            maxHinterest = maxHinterestArr(h)*zs;
            fprintf(fileID, '%s\r\n', ' ');
            fprintf(fileID, '%s', '        Max height of interest:');
            fprintf(fileID, '%4.3f\r\r\n', maxHinterest);
            fprintf(fileID, '%s\r\n', ' ');
            
            fprintf(fileID, '%s\r\n', ' ');
      
            for m =1:length(gVect)
                %deltaZfdm = 0.009- m*0.003; %0.009:-0.002:0.001
                %m
                g = gVect(m);
                %g
                fprintf(fileID, '%s\r\n', ' ');
                fprintf(fileID, '%s', '        New g value:');
                fprintf(fileID, '%4.3f\r\r\n', g);
                fprintf(fileID, '%s\r\n', ' ');
                
                %deltaXvect = [1.5]; % [0.5 0.7 1 1.2 1.5];
                
                %for n = 1:length(deltaXvect)
                n = b;
                    counter = counter +1;
                    sourceShape = 'gaussian1';
                    % Creating zVect and initial field:
                    [zVectSSA,HindexSSA] =createZvectAbsorptionLayer(maxHinterest,deltaZ);
                    initialFieldSSA = createInitialField(zs,theta0,beta,zVectSSA,A, frequency,sourceShape);
                    
                    deltaX = 1.5; % xVect(2,1) - xVect(1,1);
                    xVect = verticalVector([0:deltaX:maxX]);
                    
                    fprintf(fileID, '%s', '            New delta x value: ');
                    fprintf(fileID, '%4.3f\r\n', deltaX);
                    
                    %xVect = verticalVector([0:deltaX:maxX]);
                    alpha = -0.1;
                    % Calculating the field:%                    
                    disp('begynner utregning');
                    tic
                    uValuesSplitStep = splitStepAlgorithmAbsorptionLayer(initialFieldSSA,zVectSSA,xVect, ...
                        HindexSSA,frequency,numPtsAbsoptionLayer);
                    toc
                    
                    
                    eField1 = uValuesSplitStep(ceil(HindexSSA*(zs/maxHinterest)):ceil(HindexSSA*(zs/maxHinterest)),:);
                    simulationType{counter,1} = ['SSA:', ' ','\Deltax =', ' ', ...
                        num2str(deltaXvect(n)),', max h: ', ...
                        ' ', num2str(maxHinterestArr(h)), ', ', '\Deltaz =',...
                        ' ',num2str(deltaZ),', ', 'Ant. h: ',num2str(antHeight(a))];
                    
                    % Plotting both eFields in the same plot
                    if counter == 1
                        eFieldTot = eField1;
                        %uValuesTot = uValuesSplitStep;
                    else
                        eFieldTot = vertcat(eFieldTot,eField1); %,eField2);
                        %uValuesTot = horzcat(uValuesTot,uValuesSplitStep);
                    end
                %end
            end
            disp('Skal plotte feltet');
            fig = figure('visible','off');
            titleVal2 = ['SSA:', ' ','\Deltax =', ' ', ...
                num2str(deltaXvect(n)),', max h: ', ...
                ' ', num2str(maxHinterestArr(h)), ', ', '\Deltaz =',...
                ' ',num2str(deltaZ),', ', 'Ant. h: ',num2str(antHeight(a))];
            titleVal3 = ['Number of points in absorption layer: ', ...
                num2str(numPtsAbsoptionLayer)];
            titleVal = {titleVal2;titleVal3};
            %contourf(abs(uValuesFiniteDiffMethod).^2,50)
            uValuesSplitStep(abs(uValuesSplitStep)<10^-4) = 10^-4;
            contourf(xVect,zVectSSA,10.*log10(abs(uValuesSplitStep).^2),50)
            hold on
            contour(xVect,zVectSSA,10.*log10(abs(uValuesSplitStep).^2),50)
            title(titleVal)
            xlabel('The surface');
            ylabel('Height above surface')
            grid on
            titleValFig = ['SSA_results/SSA', '_','Delta_x_', ...
                num2str(deltaXvect(n)),'_max_h_', ...
                '_', num2str(maxHinterestArr(h)), '_', 'Delta_z_',...
                num2str(deltaZ),'_', 'Ant_h_',num2str(antHeight(a)),...
                'num_points_abs_layer',num2str(numPtsAbsoptionLayer),...
                '.png'];
            saveas(fig,titleValFig,'png');
        end
       
        titleVal3 = ['SSA - analytical beam param',', ',...
            'Antenna height:',' ', num2str(antHeight(a)),...
            ', Antenna height :',num2str(antHeight(a)) ];
        titleValFig = ['SSA_results/SSA', '_','Delta_x_', ...
                num2str(deltaXvect(n)),'_max_h_', ...
                '_', num2str(maxHinterestArr(h)), '_', 'Delta_z_',...
                num2str(deltaZ),'_', 'Ant_h_',num2str(antHeight(a)),'.png'];
        pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
            beta,frequency,simulationType, titleVal3,titleValFig);
       
        
    end
    
    
end
fclose(fileID);








