% parabolicEquationWideAngle.m: Testes functions implemented for wide
%                               angle applications.


% A necessary condition is non-singular matrices --> length(xVect) =
% length(zVect)

maxHinterest = 60;
zs = 7.5;
theta0 = 0;
beta = 0.5;
A = 1;
frequency = 100*10^6;
maxX = 3000; %10000;
g = 1.3;

% Setting deltaZ:
deltaZfdm = 0.05;


% Creating zVect and initial field:
[zVectFDM,HindexFDM] =createZvectAbsorptionLayer(maxHinterest,deltaZfdm);
zVectFDM = zVectFDM(1:3000,1);
initialFieldFDM = double(createInitialField(zs,theta0,beta,zVectFDM,A, frequency));
%plot(abs(initialFieldFDM))

% Creating xVect:
% xVect = verticalVector(linspace(0,maxX,length(zVectFDM)));
% deltaX = xVect(2,1) - xVect(1,1);

deltaX = 0.9;
maxX = (length(zVectFDM)-1)*deltaX;
xVect = verticalVector([0:deltaX:maxX]);

% Calculating the field:

tic
[uValuesFDM] = FDMwideAngleFlat(initialFieldFDM, ...
    zVectFDM,xVect,HindexFDM,frequency,g);
toc
%%
% Plotting the result:
figure(1)
contourf(10.*log10(abs(uValuesFDM).^2),30)
title('E-field - Finite-difference method - wide angle')
xlabel('The surface');
ylabel('Height above surface')
grid on

% Path loss:
eField = uValuesFDM(ceil(HindexFDM*(zs/maxHinterest)):ceil(HindexFDM*(zs/maxHinterest)),:);
simulationType = cell(1);
simulationType{1} = 'Finite-Difference Method';
rx = zs;
tx = zs;
colors = 'g';
pathLossFlat(tx,rx,xVect,eField,zs, frequency, simulationType,colors);
