% solveTridiagonalMatrix.m: Solves a set of linear equations, where the
%                           matrix is a tridiagonal matrix.
%                           triDiagMat*unknowns = result
% triDiagMat: Tridiagonal (square) matrix
% result: the result (solution) of the linear system
% return: unknowns: vector containing the originally unknowns in the linear
%                   system


function unknowns = solveTridiagonalMatrix(triDiagMat,result)

[subDiagonalEli,intmResult] = subDiagonalElimination(triDiagMat,result);
[supDiagonalEli,resultOut] = supDiagonalElimination(subDiagonalEli,intmResult);

% Solve the equations:

unknowns = double(resultOut./diag(supDiagonalEli));
end



