% testSquareMatrix.m: Tests the hypothesis regarding square matrices easier
%                     give stability, for a maximum delta x. The range
%                     being calculated depends on delta z. This is for the
%                     finite-difference method.

testResults = 'testResults_testSquareMatrix7_bugFixMatrix.txt';
fileID = fopen(testResults, 'w');
fprintf(fileID, '%s\r\n', 'Testing stability for square matrices where delta x = 1.5m');
fprintf(fileID, '%s\r\n', ' ');


theta0 = 0; %pi/4;% 0;
beta = pi/15; % pi/2; %pi/6; %pi/100; % 0.5;
A = 2;
frequency = 100*10^6;
fprintf(fileID, '%s', 'Frequency: ');
fprintf(fileID, '%e Hz\r\n', frequency);

%g = 1.3;
% fprintf(fileID, '%s', 'g value: ');
% fprintf(fileID, '%4.3f\r\r\n', g);

% The delta x value:
deltaX = 1.5;
fprintf(fileID, '%s', 'Delta x: ');
fprintf(fileID, '%4.3f\r\r\n', deltaX);
maxX = 10000; %3000;
fprintf(fileID, '%s', 'Max x: ');
fprintf(fileID, '%4.3f\r\r\n', maxX);
fprintf(fileID, '%s\r\n', ' ');
fprintf(fileID, '%s\r\n', ' ');

% The delta z value:
deltaZarr =0.5; %1; % 1.5; %0.09; %[0.5 0.3]; % [0.6 0.55 0.525 0.5 0.475 0.45 0.4 0.35 0.3]; %[0.3 0.2 0.1 0.09];
for b = 1: length(deltaZarr)
    deltaZ = deltaZarr(b);
    fprintf(fileID, '%s', 'Delta z: ');
    fprintf(fileID, '%4.3f\r\n', deltaZ);
    
    
    antHeight = 7.5; %[2 7.5 10]; %[7.5]; % 10];
    for a =1:length(antHeight)
        zs = antHeight(a);
        fprintf(fileID, '%s\r\n', ' ');
        fprintf(fileID, '%s', '    Antenna height: ');
        fprintf(fileID, '%4.2f m\r\n', zs);
        maxHinterestHeight =50; %200; %[8 25 50]; % [8]; % 14 50];
        gVect = 1.1; %[1.01 1.3 1.5];
        simulationType {length(maxHinterestHeight)*length(gVect),1} = [];
        counter = 0;
        for heightIndex = 1: length(maxHinterestHeight) %4:5 % 2:3
            maxHinterest = maxHinterestHeight(heightIndex)*zs; % heightIndex*zs;
            fprintf(fileID, '%s', '        Maximum height of interest (in terms of multiple of antenna height): ');
            fprintf(fileID, '%4.2f m\r\n', maxHinterestHeight(heightIndex));
            
            
            for g = 1:length(gVect)
                counter = counter +1;
                [zVectFDM,HindexFDM] =createZvectAbsorptionLayer(maxHinterest,deltaZ);
                sourceShape = 'gaussian1'; % 'circular';
                initialFieldFDM = createInitialField(zs,theta0,beta,zVectFDM,A, frequency,sourceShape);
                numZpoints = length(zVectFDM);
                figure()
                plot(abs(initialFieldFDM))
                
                % Creating the x vector:
                xVect = verticalVector([0:deltaX:maxX]);
                numXpoints = length(xVect);
                
                fprintf(fileID, '%s', '        Distance: ');
                fprintf(fileID, '%5.1f\r\n', xVect(numXpoints));
                
                
                
                tic
                [uValuesFDMalne,maxEigVal] = FDMAbsorptionLayerNumEfficient(initialFieldFDM, ...
                    zVectFDM,xVect,HindexFDM,frequency,gVect(g));
                
                toc
                
                fprintf(fileID, '%s', '        Maximum eigenvalue:');
                fprintf(fileID, '%4.6f\r\n', maxEigVal);
                fprintf(fileID, '%s\r\n', ' ');
                
                deltaZstr = num2str(deltaZ);
                yText = strcat('Height above surface, \Delta z ',deltaZstr);
                %
                
                eField = uValuesFDMalne(ceil(HindexFDM*(zs/maxHinterest)):ceil(HindexFDM*(zs/maxHinterest)),:);
                %             simulationType2 = cell(1);
                %             simulationType2{1} = 'FDM-bc';
                simulationType{counter,1} = ['FDM:', ' ','\Deltax =', ' ', ...
                    num2str(deltaX),', maximum height of interest: ', ...
                    ' ', num2str(maxHinterestHeight(heightIndex)),' ','g=',num2str(g)];
                tx = zs;
                rx = zs;
                
                if counter == 1
                    eFieldTot = eField;
                else
                    eFieldTot = vertcat(eFieldTot,eField);
                end
                
                
                figure()
                titleVal2 = ['FDM, square matrix, antenna height:',' ',num2str(antHeight(a)), ...
                    ' ','\Deltaz = ',' ',deltaZstr,', ','\Deltax = ', ...
                    num2str(deltaX),' ','g=',num2str(gVect(g))];
                %contourf(abs(uValuesFiniteDiffMethod).^2,50)
                %contourf(xVect,zVectFDM,10.*log10(abs(uValuesFDMalne(1:1*HindexFDM,:)).^2),20)
                uValuesFDMalne(abs(uValuesFDMalne)<10^-3) = 10^-3;
                contourf(xVect,zVectFDM,10.*log10(abs(uValuesFDMalne.^2)),20)
                title(titleVal2)
                xlabel('The surface');
                ylabel(yText); %'Height above surface, \Delta z = %2.1f', deltaZ)
                grid on
                
            end
        end
        titleVal = ['FDM, square matrix, antenna height:','m,',' ',num2str(antHeight(a)), ...
            ' ','\Deltaz = ',' ',deltaZstr,', ','\Deltax = ',' ', ...
            num2str(deltaX), 'Source shape:',' ',sourceShape];
        pathLossFlat(tx,rx,xVect,eFieldTot,zs, frequency, simulationType,titleVal);
        A = 1;
        
         titleVal3 = ['FDM - analytical beam param, square matrix, antenna height:','m,',' ',num2str(antHeight(a)), ...
            ' ','\Deltaz = ',' ',deltaZstr,', ','\Deltax = ',' ', ...
            num2str(deltaX), 'Source shape:',' ',sourceShape];
        pathLossFlat_beamParam(A,tx,rx,xVect,eFieldTot,zs,...
    beta,frequency,simulationType, titleVal3);

    end
end

fclose(fileID);




